/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		
	templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/InvitationCustomizationDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
	
	constructor: function (args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.descriptionNode = document.createTextNode(args.description);
		this.emptySubjectNode = document.createTextNode(this.messages.InvitationCustomizationDialog_1);
		this.emptyBodyNode = document.createTextNode(this.messages.InvitationCustomizationDialog_2);
		this.errorState = false;
		this.currentNode = null;
	},
	
	postCreate: function () {
		this.reset(this);
		this.connect(this.emailSubject, "onkeyup", "verifySubjectAndBody"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.emailSubject, "onchange", "verifySubjectAndBody"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.emailBody, "onkeyup", "verifySubjectAndBody"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.emailBody, "onchange", "verifySubjectAndBody"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	verifySubjectAndBody: function (e) {
		if (this.emailSubject.value == null || dojo.string.trim(this.emailSubject.value).length == 0) {
			this.setDescription(this.emptySubjectNode, true);
		}
		else {
			if (this.emailBody.value == null || dojo.string.trim(this.emailBody.value).length == 0) {
				this.setDescription(this.emptyBodyNode, true);
			}
			else {
				this.setDescription(this.descriptionNode, false);
			}
		}
	},
	
	setDescription: function (node, isError) {
		if (this.currentNode != node) {
    		dojox.data.dom.removeChildren(this.invitationDescription);
    		this.invitationDescription.appendChild(node);
		}
		
		this.errorState = isError;
		this.finishButton.disabled = isError;
	},
		
	reset: function(args) {
		this.setDescription(this.descriptionNode, false);
		
		this.emailSubject.value = args.subject;
		this.emailBody.value = args.message;
		
		if (this.singleUserObj) {
			this.emailBody.rows = 6;
			this.invitationPropertiesDiv.style.display = "inline"; //$NON-NLS-1$
			this.invitationProperties.value = args.properties;
		} else {
			this.emailBody.rows = 12;
			this.invitationPropertiesDiv.style.display = "none"; //$NON-NLS-1$
		}
	},
	
	getEmailSubject: function () {
		return this.emailSubject.value;
	},
	
	getEmailBody: function () {
		return this.emailBody.value;
	},
	
	getCopySelf: function () {
		return this.copySelf.checked;
	}
});

})();