/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.dnd.DraggableManager");

dojo.require("dojo.dnd.autoscroll");

(function() {
	com.ibm.team.dashboard.web.ui.internal.dnd.DraggableManager = function(){
		this.avatar = null;
		this.containers = new Array();
		this.fromContainer = null;
		this.overContainer = null;
		this.widget = null;
		this.before = true;
		this.isDragging = false;
		this.paused = false;
		this.events = new Array();
		this.targets = new Array();
		this.maxRow = 0;  //set during drag operations in constrainAvatar = "A" containers
	};
	
	dojo.extend(com.ibm.team.dashboard.web.ui.internal.dnd.DraggableManager, {
			destroy: function() {
				while (this.events && this.events.length > 0) {
					dojo.disconnect(this.events.pop());
					com.ibm.team.dashboard.web.ui.internal.dnd._draggableManager = null;
				}
			},
			onMouseMove: function(e){
				if (this.paused) return;
				this.fromContainer.checkDrag(e);
				var difX = Math.abs(e.pageX - this.initialX);
				var difY = Math.abs(e.pageY - this.initialY);
				if (!this.isDragging && (difX >= 4 || difY >= 4)) {
					this.startDrag();
				} else if (!this.isDragging) {
					return;
				}
				var a = this.avatar;
				if(a){
					var x = this.offsetX;
					var y = this.offsetY + this.fromContainer.WIDGET_TOP_MARGIN;
					if (this.fromContainer.constrainAvatar && this.fromContainer.constrainAvatar == "A") {
						if (!this.yStart) {
							this.yStart = this.containerCoords.y;
						}
						this.maxRow = Math.round(this.overContainer.node.parentNode.clientHeight / this.widgetCoords.h) - 1;
						var row = Math.round(((e.pageY - y) - (this.containerCoords.y)) / this.widgetCoords.h);
						
						if (row >= 0 && row <= this.maxRow) {
							this.yStart = this.containerCoords.y + Math.round(row) * this.widgetCoords.h;
							if (dojo.isIE) this.yStart = this.yStart - dojo.style(this.widget.domNode, "marginTop");
						}
						
						if (e.pageX - x < this.containerCoords.x) {
							dojo.marginBox(a.node, {l: this.containerCoords.x, t: this.yStart});
							this.atStart = true;	
							this.atEnd = false;
							this.atRowEnd = false;
						} else if (e.pageX - x > this.containerCoords.x + this.containerCoords.w - this.widgetCoords.w - 8) {
							dojo.marginBox(a.node, {l: this.containerCoords.x + this.containerCoords.w - this.widgetCoords.w - 8, t: this.yStart});
							this.atStart = false;
							if (this.maxRow == row)
								this.atEnd = true;
							else {
								this.atEnd = false;
							}
							this.atRowEnd = true;
						} else {
							dojo.marginBox(a.node, {l: e.pageX - x, t: this.yStart});
							var lastItemCoords = dojo.coords(this.overContainer.widgets[this.overContainer.widgets.length-1].domNode, true);
							if (row == this.maxRow && (e.pageX - x > this.containerCoords.x + this.containerCoords.w - this.widgetCoords.w - 10 || e.pageX - x > lastItemCoords.x+lastItemCoords.w)) {
								if (row == this.maxRow)
									this.atEnd = true;
								else 
									this.atEnd = false;
								this.atRowEnd = true;					
								this.atStart = false;
							} else if (e.pageX - x < this.containerCoords.x + 18) {
								this.atEnd = false;
								this.atRowEnd = false;
								this.atStart = true;
							} else {
								this.atEnd = false;
								this.atRowEnd = false;
								this.atStart = false;	
							}
						}
					} else if (this.fromContainer.constrainAvatar && this.fromContainer.constrainAvatar == "X") {
						if (!this.yStart) {
							this.yStart = this.containerCoords.y + this.fromContainer.WIDGET_TOP_MARGIN;
						}
						if (e.pageX - x < this.containerCoords.x) {
							dojo.marginBox(a.node, {l: this.containerCoords.x, t: this.yStart});
						} else {
							dojo.marginBox(a.node, {l: e.pageX - x, t: this.yStart});
						}
					} else if (this.fromContainer.constrainAvatar && this.fromContainer.constrainAvatar == "Y") {
						if (!this.xStart) {
							this.xStart = this.containerCoords.x + this.fromContainer.WIDGET_LEFT_MARGIN;
						}
						if (e.pageY - y < this.containerCoords.y) {
							dojo.marginBox(a.node, {l: this.xStart, t: this.containerCoords.y});	
						} else {
							dojo.marginBox(a.node, {l: this.xStart, t: e.pageY - y});
						}
					} else {
						dojo.marginBox(a.node, {l: e.pageX - x, t: e.pageY - y});	
					}
				}
				
				var x = e.pageX;
				var y = e.pageY;
				var containers = this.containers;
				for (var i = 0; i < containers.length; i++) {
					var widget = this.widget;
					if (containers[i] && dojo.isDescendant(containers[i].node, document.body) && dojo.some(containers[i].accept, function(type){ return type == widget.type; })) {
						var coords = {
							xy: dojo.coords(containers[i].node, true),
							w: containers[i].node.offsetWidth,
							h: containers[i].node.offsetHeight
						};
						
						if ((this.fromContainer.constrainAvatar && (this.fromContainer.constrainAvatar == "Y" || this.fromContainer.constrainAvatar == "A")) || (x >= coords.xy.x && x <= coords.xy.x + coords.w)) {
							if ((this.fromContainer.constrainAvatar && (this.fromContainer.constrainAvatar == "X" || this.fromContainer.constrainAvatar == "A")) || (y >= coords.xy.y && y <= coords.xy.y + coords.h)) {
								if (this.overContainer && containers[i] != this.overContainer) {
									containers[i].checkPlaceholder();
								}
								if (this.overContainer && this.overContainer.node)
									dojo.removeClass(this.overContainer.node,"dndOver");
								this.overContainer = containers[i];
								containers[i].onMouseMove(e);
								return;
							}
						}
					}
				}
				var targets = this.targets;
				for (var i = 0; i < targets.length; i++) {
					if (targets[i] && dojo.isDescendant(targets[i].node, document.body) && dojo.some(targets[i].accept, function(type){ return type == widget.type; })) {
						var coords = {
							xy: dojo.coords(targets[i].node, true),
							w: targets[i].node.offsetWidth,
							h: targets[i].node.offsetHeight
						};
						
						if (x >= coords.xy.x && x <= coords.xy.x + coords.w) {
							if (y >= coords.xy.y && y <= coords.xy.y + coords.h) {
								targets[i].checkPlaceholder();
								if (this.overContainer && this.overContainer.node)
									dojo.removeClass(this.overContainer.node,"dndOver");								
								this.overContainer = targets[i];
								dojo.addClass(targets[i].node,"dndOver");
							}
						}
					}
				}
				if (this.atEnd || this.atStart) {
					this.fromContainer.onMouseMove(e);	
				}
			},
			initDrag: function(container, widget){
				this.events.push(dojo.connect(dojo.doc, "onmousemove", this, "onMouseMove"));
				this.widget = widget;
				this.fromContainer = container;
				this.overContainer = container;
			},
			startDrag: function(){
				if (this.widget.isZoomed) {
					this.widget.toggleZoom(null, true);
				}
				if (this.overContainer) {
					if (this.overContainer != this.fromContainer) {
						if (this.overContainer.node)
							dojo.removeClass(this.overContainer.node,"dndOver");
						this.overContainer = this.fromContainer;
					}
				} else if (this.fromContainer) {
					this.overContainer = this.fromContainer;
				}
				this.isDragging = true;
				this._scrollMaxX = document.documentElement.scrollWidth-document.documentElement.clientWidth;
				this._scrollMaxY = document.documentElement.scrollHeight-document.documentElement.clientHeight;
				this.containerCoords = dojo.coords(this.fromContainer.node, true);
				this.avatar = new com.ibm.team.dashboard.web.ui.internal.dnd.Avatar(this, this.fromContainer.avatarClass);
				dojo.body().appendChild(this.avatar.node);
			},
			stopDrag: function(){
				dojo.forEach(this.events, dojo.disconnect);
				if (!this.overContainer.isSource) {
					dojo.removeClass(this.overContainer.node,"dndOver");
				}
				while (this.events.length > 0) {
					dojo.disconnect(this.events.pop());
				}	
				this.events = new Array();
				if (this.isDragging) {
					this.avatar.destroy();
				}
				this.avatar = null;
				this.fromContainer = null;
				this.overContainer = null;
				this.widget = null;
				this.isDragging = false;
				this.yStart = null;
				this.xStart = null;
				this.widgetCoords = null;
				this.containerCoords = null;
				this.atEnd = false;
				this.atStart = false;
				this.paused = false;
			},
			stopForInput: function() {
				this.paused = true;
			}
	});
	
	com.ibm.team.dashboard.web.ui.internal.dnd._draggableManager = null;
	
	com.ibm.team.dashboard.web.ui.internal.dnd.draggableManager = function(){
		if(!com.ibm.team.dashboard.web.ui.internal.dnd._draggableManager){
			com.ibm.team.dashboard.web.ui.internal.dnd._draggableManager = new com.ibm.team.dashboard.web.ui.internal.dnd.DraggableManager();
		}
		return com.ibm.team.dashboard.web.ui.internal.dnd._draggableManager;
	};
})();