/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.dnd.Target");

dojo.require("com.ibm.team.dashboard.web.ui.internal.dnd.DraggableContainer");
dojo.require("com.ibm.team.dashboard.web.ui.internal.dnd.DraggableManager");

(function() {
	var draggableManager = com.ibm.team.dashboard.web.ui.internal.dnd.draggableManager;
	
	dojo.declare("com.ibm.team.dashboard.web.ui.internal.dnd.Target", com.ibm.team.dashboard.web.ui.internal.dnd.DraggableContainer, {
		constructor: function(node, params){
			this.isSource = false;
			this.index = params.index;
			this.dashboardContainer = params.dashboardContainer;
		},
		destroy: function() {
			var targets = draggableManager().targets;
			for (var i = 0; i < targets.length; i++ ) {
				if (targets[i] == this) {
					targets.splice(i,1);
					break;
				}	
			}
			this.inherited(arguments);
		},
		/* Move
		 * 
		 * return: cancelDrag - true/false 
		 * 
		 */
		move: function(fromIndex, toTabIndex) {
			if (draggableManager().widget._viewlet.isEditing()) {
				draggableManager().stopForInput();
				if(!draggableManager().widget.stopEditing()) {
					return true;
				}
			}
			try {
				var viewletHelper = draggableManager().widget._viewletHelper;
				viewletHelper.getDashboardItem().moveViewlet(viewletHelper.getId(), toTabIndex, 0, 0);
			} catch (err) {
				console.error("New viewlet position could not be saved: " + err.message + " - Refreshing viewlet page.");
			}
			var fromContainer = draggableManager().fromContainer;
			
			var widget = fromContainer.widgets.splice(fromIndex,1)[0];
			widget.domNode.parentNode.removeChild(widget.domNode);
			this.dashboardContainer.setDirty(toTabIndex);
			this.dashboardContainer.checkEmpty();
			this.updateIndices(fromContainer);
			widget.destroy();
			return false;
		},
		registerContainer: function() {
			draggableManager().targets.push(this);
		}
	});
})();