/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.WorkItemWelcome");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");

(function() {

var WorkItemUtil 		= com.ibm.team.workitem.web.client.util;

/**
 * Provides a UI to iterate through the work items in a query result.
 */
/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.page.WorkItemWelcome",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/page/templates/WorkItemWelcome.html"),
		// Style in WorkItemPageView.css
        constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			this.textWelcomeToWorkItems = this.messages.msgWelcomeToWorkItems;		
			this.textWelcomeMessage = dojo.string.substitute( this.messages.msgWelcomeText, 
					["#action=com.ibm.team.workitem.newWorkItem", "#action=com.ibm.team.workitem.newQuery"]);

			this.textError = this.messages.msgError;
			this.textAnErrorOccured = this.messages.msgAnErrorOccured;

		},			
		postCreate: function() {

			this.clearErrorMessage();
		},
		initializeWorkItemLinks: function(args) {

		},
		initializeQueryLinks: function(results) {

		},
		setErrorMessage: function(msg) {
			this._welcome.style.display="none";
			this._error.style.display="";
			dojox.data.dom.replaceChildren(this._errorMsg, document.createTextNode(msg));
		},
		clearErrorMessage: function() {
			this._error.style.display="none";
			this._welcome.style.display="";
			dojox.data.dom.removeChildren(this._errorMsg);
		}
	}
);

})();